// DataInput.h: interface for the CDataInput class.
//
// Coded by Henryk Cygert
// Gdynia 1999 Poland
// e-mail:hcygert@optix.pl
//
//////////////////////////////////////////////////////////////////////

#ifndef __CDataInput
#define __CDataInput


enum DEK_STATUS {
	DS_OK = 0,
	DS_END,		// Koniec danych
	DS_WAIT,	// Czekaj
	DS_ERROR,	// Bd
};

enum DEK_CHANEL {
	DC_STEREO,
	DC_LEFT,
	DC_RIGHT,
};


class CDataInput  
{
public:
	virtual BOOL Open(DEK_CHANEL Mode) = 0;
	virtual BOOL Close() = 0;
	// przetwarza nastpny blok danych
	virtual DEK_STATUS ProcessNextBlock() = 0;

	char *GetLastError() {return m_Msg;}
	BYTE *GetBuffer() {return m_Buffer;}
	DWORD GetSize() {return m_Size;}

	CDataInput();
	virtual ~CDataInput();
protected:
	DEK_CHANEL m_Mode;
	char m_Msg[256];
	BYTE *m_Buffer;
	DWORD m_Size;
	BOOL m_OK;
};

#endif	//__CDataInput