// FileLoader.cpp: implementation of the CFileLoader class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "AtariReceiver.h"
#include "FileLoader.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CFileLoader::CFileLoader()
{
	static char BASED_CODE szFilter[] = "Wave files (*.wav)|*.wav|Raw files (*.raw)|*.raw||";
	m_dlg = new CFileDialog(TRUE,0,0,OFN_ALLOWMULTISELECT|OFN_LONGNAMES|OFN_FILEMUSTEXIST|OFN_PATHMUSTEXIST,
			szFilter,0);
	m_pos=0;
}

CFileLoader::~CFileLoader()
{
	Close();
	if(m_dlg) {
		delete m_dlg;
		m_dlg = 0;
	}
}


BOOL CFileLoader::Open(DEK_CHANEL Mode)
{
	m_Mode=Mode;
	if(Close()) {
		m_Msg[0]=0;
		m_pos=0;
		if(IDOK == m_dlg->DoModal()) {
			m_pos = m_dlg->GetStartPosition();
			if(m_pos) {
				return TRUE;
			}
		}
		sprintf(m_Msg,"No files selected");
	}
	return FALSE;
}


BOOL CFileLoader::Close()
{
	if(m_Buffer) {
		GlobalFree(m_Buffer);
		m_Buffer=0;
	}
	m_Size=0;
	return TRUE;
}

DEK_STATUS CFileLoader::ProcessNextBlock()
{
	if(m_dlg) {
		if(m_pos) {
			CString Name;
			Name = m_dlg->GetNextPathName(m_pos);
			if(Name != "") {
				if(LoadFile((char*)((LPCTSTR)Name))) {
					return DS_OK;
				}
			}
		}
	}
	return DS_ERROR;
}


BOOL CFileLoader::LoadFile(char *FName)
{
	FILE *f;
	DWORD Size;
	BOOL ret=FALSE;
	if(m_Buffer) {
		GlobalFree(m_Buffer);
		m_Buffer=0;
	}
	m_Size=0;
	if(f=fopen(FName,"rb")) {
		if(0 == fseek(f,0,SEEK_END)) {
			Size=ftell(f);
			fseek(f,0,SEEK_SET);
			if(Size != 0xFFFFFFFF) {
				m_Buffer=(BYTE*)GlobalAlloc(GMEM_FIXED,Size);
				if(m_Buffer) {
					if(Size == fread(m_Buffer,1,Size,f)) {
						m_Size=Size;
						ret=TRUE;
					}
				}
			}
		}
		fclose(f);
	}
	return ret;
}


