// System.h: interface for the CSystem class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SYSTEM_H__3F6EBA81_96D8_11D3_81A9_DE537CED1C52__INCLUDED_)
#define AFX_SYSTEM_H__3F6EBA81_96D8_11D3_81A9_DE537CED1C52__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "AtariDekoder.h"
#include "DataInput.h"

class CSystem  
{
public:
	BOOL Close();
	BOOL Open(DEK_CHANEL Mode, volatile BOOL *bAbort, char *szDstDirectory, BOOL bReadExisting);
	// Gdy zwraca 0, to bd odczytu
	// w przeciwnym wypadku zwraca nazw odczytanego pliku
	virtual char * ProcessHeader() =0;

	// Zwraca 0 gdy bd odczytu
	// 0xFFFFFFFF - gdy koniec pliku
	// 0x8000XXXX - used existing
	// w przeciwnym wypadku numer odczytanego bloku (1 ... N)
	virtual DWORD ProcessData() = 0;

	// Number of the block
	DWORD	BlockNr() {return dwBlockNr;}
	// Size of readed block
	DWORD	BlockSize() {return dwReadedSize;}

	// Total file size
	DWORD	FileSize() {return dwFileSize;}
	// File name
	char *FileName() {return szFileName;}

	char *GetLastError() {return m_Msg;}

	CSystem(CAtariDekoder *dek, CDataInput *inp);
	virtual ~CSystem();

protected:
	BOOL RenameFile();
	
	// returning readed size or 0xFFFFFFFF if error
	DWORD ReadExisting(BYTE *lpBuf, DWORD Size);
	BOOL SaveData(BYTE *lpBuf, DWORD Size);
	void FillFileName(BYTE *FName);
	DEK_RESULT LoadData();
	BOOL ReallocBuffer(DWORD Size);
	BOOL Abort() {return m_abort[0];}
	BOOL Init();
	// Funkcja skada nazw pliku ze ciek i dodaje kolejny
	// numerek do nazwy gdy to konieczne.
	BOOL GetFreeFileName(char *Dst, char *Path, char *FName);
	void Path_Link(char *Dst, char *Path, char *FName);
	char szFileName[16];
	DWORD dwFileSize;
	DWORD dwBlockNr;
	BYTE *lpBuffer;
	DWORD dwBufSize;
	DWORD dwReadedSize;
	CAtariDekoder *m_dek;
	CDataInput *m_inp;
	char m_Msg[256];
	BOOL m_OK;
	BOOL m_bReadExisting;
	volatile BOOL *m_abort;
	char szDstDir[MAX_PATH];
	char szDstFName[MAX_PATH];
};

#endif // !defined(AFX_SYSTEM_H__3F6EBA81_96D8_11D3_81A9_DE537CED1C52__INCLUDED_)
