// AtariReceiverDlg.h : header file
//
// Coded by Henryk Cygert
// Gdynia 1999 Poland
// e-mail:hcygert@optix.pl
//

#if !defined(__CAtariReceiverDlg)
#define __CAtariReceiverDlg

/////////////////////////////////////////////////////////////////////////////
// CAtariReceiverDlg dialog

#include "Recorder.h"
#include "AtariDekoder.h"

enum ARD_MODE {
	DISABLED,
	WAITING,
	RECEIVEING,
};


class CAtariReceiverDlg : public CDialog
{
// Construction
public:
	CAtariReceiverDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CAtariReceiverDlg)
	enum { IDD = IDD_ATARIRECEIVER_DIALOG };
	CButton	m_UseDst;
	CButton	m_DstInfo;
	CEdit	m_Log;
	CComboBox	m_Device;
	CComboBox	m_Channel;
	CButton	m_File_Dst;
	CButton	m_Cancel;
	CButton	m_About;
	CButton	m_Stop;
	CButton	m_Start;
	int		m_vChannel;
	int		m_vDevice;
	BOOL	m_vUseDst;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAtariReceiverDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CAtariReceiverDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnExit();
	afx_msg void OnButtonStart();
	afx_msg void OnButtonStop();
	afx_msg void OnButtonFileDestination();
	afx_msg void OnButtonClearLog();
	afx_msg void OnButtonAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void SaveConfig();
	void StopThread();
	void StartThread();
public:
	void LoadConfig();
	void UpdateMode();
	void Info_Out(LPCTSTR szString, void *Val1=0,void *Val2=0, void *Val3=0, void *Val4=0);
	CRecorder m_rec;
	volatile BOOL	m_StopThread;
	ARD_MODE m_Mode;
	CString m_DstPath;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(__CAtariReceiverDlg)
