// DekoderFM2XL.cpp: implementation of the CDekoderFM2XL class.
//
// Coded by Henryk Cygert
// Gdynia 1999 Poland
// e-mail:hcygert@optix.pl
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include <string.h>
#include "DekoderFM2XL.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////
#define	_HI(a)		(a+5)
#define	_LO(a)		(a-5)
#define	_midHI(a)	(a+2)
#define	_midLO(a)	(a-2)
#define SREDNIA(Var,Value) if(Var) {\
								Var+=(Value);\
								Var>>=1;\
							} else {\
								Var=(Value);\
							}



CDekoderFM2XL::CDekoderFM2XL()
{
	m_reverse=false;
	m_se=0;
	m_sp=0;
	SetNextBlock();
}

CDekoderFM2XL::~CDekoderFM2XL()
{

}

#define PULAP(a)	(((a)>>1)+((a)>>3))		//0.625*a


DEK_RESULT CDekoderFM2XL::GetNextByte(unsigned char *Byte)
{
	DEK_RESULT res;
	unsigned short Amp;
	
	while(1) {
//		if(m_VerifyCounter < _midLO(CDF_ZERO)) {
		if(m_VerifyCounter < CDF_ZERO) {
			res=FindPoint();
			if(res != DEK_OK) return res;
		}

		// Gdy brak sygnau
		if(m_Counter > CDF_LOADER*4) {
			if(m_Func == FNC_LOADER) {
				m_Func=FNC_NOTHING;
			} else {
				if(m_Func == FNC_DATA) {
					return DEK_IO_ERROR;
				}
			}
		}

		// Wszystko przebiego pomylnie ???
		switch(m_Func) {
		case FNC_NOTHING:
			if(m_Counter > _HI(CDF_LOADER)) {
				m_Loader=0;
			} else {
				if(m_Min < 128-10) {
					if(m_Counter > _HI(CDF_ONE)) {
						if(m_Loader > 10) {
							m_Func=FNC_LOADER;
						} else {
							m_Loader++;
						}
						break;
					}
				}
				// szum
				m_Loader=0;
			}
			break;
		case FNC_LOADER:
			if(m_Counter > _HI(CDF_LOADER)) {
				m_Loader=0;
				m_Func=FNC_NOTHING;
			} else {
				Amp=m_Max-m_Min;
				if(m_Counter > _HI(CDF_ONE)) {
					// Statystyka
					SREDNIA(m_AmpLoader,Amp);
					SREDNIA(m_AmpOne,Amp);	// Te dla wzoru
				} else {
					m_Loader=0;
					m_Func=FNC_DATA;
					goto Label_DATA;
				}
			}
			break;
		case FNC_DATA:
			if(m_Counter > _HI(CDF_LOADER)) {
				return DEK_IO_ERROR;
			}
Label_DATA:
			Amp=m_Max-m_Min;
			if(m_VerifyCounter) {
//				if(m_VerifyCounter < _midLO(CDF_ZERO)) {
				if(m_VerifyCounter < CDF_ZERO) {
					if(Amp < PULAP(m_AmpOne)) {	// Amp<3/4*m_AmpOne
						m_VerifyCounter+=m_Counter-CDF_ZERO;
						m_Counter=CDF_ZERO;
						Amp=m_AmpZero;
					} else {
						m_VerifyCounter=0;
						goto Label_DATA;
					}
				} else {
					if(m_VerifyCounter >= CDF_ZERO) {
						m_VerifyCounter-=CDF_ZERO;
					} else {
						m_VerifyCounter=0;
					}
					m_Counter=CDF_ZERO;
					Amp=m_AmpZero;
				}
			} else {
				if(Amp < PULAP(m_AmpOne)) {	// Amp<3/4*m_AmpOne
					// Prawdopodobnie zero, bo mniejszy od 3/4 ampl. jedynki
					if(m_Counter > _HI(CDF_ZERO)) {
//					if(m_Counter > (CDF_ZERO)) {
						m_VerifyCounter=m_Counter-CDF_ZERO;
						m_Counter=CDF_ZERO;
					} else {
						if(m_Counter < _LO(CDF_ZERO)) {
							m_VerifyCounter=m_Counter;
							break;
						}
					}
				} else {
					// Jedynka murowana
					if(m_Counter > _HI(CDF_ONE)) {
						return DEK_IO_ERROR;
					} else {
						if(m_Counter > CDF_ONE) {
							m_VerifyCounter=m_Counter-CDF_ONE;
						}
					}
				}
			}
/*###		if(m_Counter > _HI(CDF_ZERO)) {
				// Czy jedynka ???
				if(Amp < ((m_AmpOne+m_AmpZero)>>1)) {
					// Prawdopodobnie zero
					if(((m_VerifyCounter+m_Counter)>>1) < _HI(CDF_ZERO)) {
						m_Counter=CDF_ZERO;
					}
				}
			}*/
			m_ActByte<<=1;
			if(m_Counter > _HI(CDF_ZERO)) {
				// Jedynka
				m_ActByte|=1;
				SREDNIA(m_AmpOne,Amp);
			} else {
				// Zero
				SREDNIA(m_AmpZero,Amp);
			}
			m_ActBits++;
			break;
		}
		m_Counter=0;
		m_Max=0x00;
		m_Min=0xFF;
		if(m_ActBits == 8) {
			m_ActBits=0;
			Byte[0]=m_ActByte;
			break;
		}
	}
	return DEK_OK;
}



void CDekoderFM2XL::SetNextBlock()
{
	m_Func=FNC_NOTHING;
	m_Last=128;
	m_Min=0xFF;
	m_Max=0;
	m_Counter=0;
	m_Loader=0;
	m_AmpLoader=0;
	m_AmpOne=0;
	m_AmpZero=0;
	m_ActBits=0;
	m_VerifyCounter=0;
}

DEK_RESULT CDekoderFM2XL::ReadStack()
{
	if(m_InPtr == 0) return DEK_NO_BUFFER;
	unsigned long Size=m_InEnd-m_InPtr;
	unsigned long spSize=m_se-m_sp;
	DEK_RESULT ret;
	if(m_sp) {
		if(spSize) memcpy(m_Stack,&m_Stack[m_sp],spSize);
		m_se-=m_sp;
		m_sp=0;
	} else {
		if(m_se == CDF_BUFFER) return DEK_OK;
	}
	if(Size >= (CDF_BUFFER-spSize)) {
		Size=CDF_BUFFER-spSize;
		ret=DEK_OK;
	} else {
		ret=DEK_OUT_OF_DATA;
	}
	if(Size) {
		if(m_reverse == false) {
			memcpy(&m_Stack[m_se],m_InPtr,Size);
		} else {
			unsigned char *dst=&m_Stack[m_se];
			unsigned char *src=m_InPtr;
			unsigned long cntr=Size;
			for(;cntr;cntr--) {
				*dst=255-*src;
				dst++;
				src++;
			}
		}
		m_se+=Size;
		m_InPtr+=Size;
	}
	return ret;
}

DEK_RESULT CDekoderFM2XL::FindPoint()
{
	register unsigned long i,j;
	register unsigned char b;
	DEK_RESULT res;
	while(1) {
		res=ReadStack();
		if(res != DEK_OK) return res;
		for(i=m_sp;i<m_se;i++) {
			b=m_Stack[i];
			if(b<m_Last) {
				// ZAKCENIE ???
				if(m_Last == m_Max) {
					if((i + CDF_DIST)<m_se) {
						// Mamy wystarczajco danych
						for(j=i+1;j<i+CDF_DIST;j++) {
							if(m_Stack[j] > m_Last) {
								// Niestety dalej ronie
								i=j-1;
								break;
							}
						}
					} else {
						// Doczytaj dane !!!
						break;
					}
				}
				m_Last=b;
			} else {
				m_Last=b;
				if(b>=m_Max) m_Max=b;
				else {
					// Zakcenie ???
					if((i + CDF_DIST)<m_se) {
						// Mamy wystarczajco danych
						for(j=i+1;j<i+CDF_DIST;j++) {
							if(m_Stack[j]<b) {
								// Niestety dalej maleje
								i=j;
								m_Last=m_Stack[j];
								break;
							}
						}
						if(i != j) {
							// skoczy opada
							m_Counter+=i;
							m_sp=i;
							m_Min=b;
							return DEK_OK;
						}
					} else {
						// Doczytaj dane !!!
						break;
					}
				}
			}
		}
		m_Counter+=i;
		m_sp=i;
	}
}
