// DekoderFM2XL.h
//
// Coded by Henryk Cygert
// Gdynia 1999 Poland
// e-mail:hcygert@optix.pl
//
//////////////////////////////////////////////////////////////////////

#ifndef __DekoderFM2XL__
#define __DekoderFM2XL__

#include "AtariDekoder.h"


#define	CDF_LOADER		44						// Dokadna szeroko loadera
#define	CDF_ONE			22						// Dokadna szeroko jedynka
#define CDF_ZERO		11						// Dokadna szeroko zera

#define	CDF_BUFFER		64						// Bufor dla przeszukiwania
#define CDF_DIST		((CDF_ZERO+1)>>1)		// Dopuszczalna szeroko zakcenia


class CDekoderFM2XL : public CAtariDekoder
{
public:
	void SetNextBlock();
	DEK_RESULT GetNextByte(unsigned char *Byte);
	CDekoderFM2XL();
	virtual ~CDekoderFM2XL();

private:
	DEK_RESULT FindPoint();
	DEK_RESULT ReadStack();

	unsigned char m_Stack[CDF_BUFFER];
	unsigned long m_sp;	// Stack Pointer
	unsigned long m_se;	// Stack End
	unsigned long m_Counter;
	unsigned long m_VerifyCounter;

	unsigned short m_AmpLoader;
	unsigned short m_AmpOne;
	unsigned short m_AmpZero;

	unsigned char m_Last;
	unsigned char m_Max;
	unsigned char m_Min;

	unsigned char m_Loader;


};

#endif