// DekoderXL.cpp: implementation of the CDekoderXL class.
//
// Coded by Henryk Cygert
// Gdynia 1999 Poland
// e-mail:hcygert@optix.pl
//
//////////////////////////////////////////////////////////////////////

//#include "stdafx.h"
#include "DekoderXL.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDekoderXL::CDekoderXL()
{
	m_HiCntr=0;
	m_LoCntr=0;

	m_Config.vHiLevel=128+32;
	m_Config.nLoader=30;
	m_Config.nOne=15;
	m_Config.nZero=7;
}

CDekoderXL::~CDekoderXL()
{

}


DEK_RESULT CDekoderXL::GetNextByte(unsigned char * Byte)
{
	if(m_InBuffer == 0) return DEK_NO_BUFFER;
	if(m_InPtr >= m_InEnd) return DEK_OUT_OF_DATA;
	DEK_RESULT ret=DEK_OK;
	register unsigned char *pos=m_InPtr;
	register unsigned char *end=m_InEnd;
	register unsigned char vHi=m_Config.vHiLevel,nByte;
	register unsigned long hCntr=m_HiCntr;
	register unsigned long lCntr=m_LoCntr;

	while(1) {
		if(pos>=end) {
			ret=DEK_OUT_OF_DATA;
			break;
		}
//		if(pos-m_InBuffer>90916) {
//			pos=pos;
//		}
		if(m_Reverse == false) {
			nByte=pos[0];
		} else {
			nByte=255-pos[0];
		}
		if(nByte>=vHi) {
			hCntr++;
			if(lCntr) {
				lCntr=0;
			}
		} else {
			lCntr++;
			if(hCntr == 0) {
				if(lCntr > (unsigned long)(m_Config.nLoader*2)) {
					if(m_Func == FNC_LOADER) {
						m_Func=FNC_NOTHING;
					} else {
						if(m_Func == FNC_DATA) {
							ret=DEK_IO_ERROR;
							break;
						}
					}
					lCntr=0;
				}
			} else {
				switch(m_Func) {
				case FNC_NOTHING:
					if(hCntr > m_Config.nLoader) {
					} else {
						if(hCntr > m_Config.nOne) {
							m_Func=FNC_LOADER;
						} else {
							// szum
						}
					}
					break;
				case FNC_LOADER:
					if(hCntr > m_Config.nLoader) {
						m_Func=FNC_NOTHING;
					} else {
						if(hCntr > m_Config.nOne) {
						} else {
							m_Func=FNC_DATA;
							goto Label_DATA;
						}
					}
					break;
				case FNC_DATA:
					if(hCntr > m_Config.nOne) {
						ret=DEK_IO_ERROR;
					} else {
Label_DATA:
						if(m_SkipFirstBit) {
							if(m_FirstBit == 0) {
								m_FirstBit=1;
								break;
							}
						}
						m_ActByte<<=1;
						if(hCntr > m_Config.nZero) {
							// Jedynka
							m_ActByte|=1;
						} else {
							// Zero
						}
						m_ActBits++;
					}
					break;
				}
				hCntr=0;
				if(ret != DEK_OK) break;
				if(m_ActBits == 8) {
					m_ActBits=0;
					pos++;
					break;
				}
			}
		}
		pos++;
	}
	Byte[0]=m_ActByte;
	m_HiCntr=hCntr;
	m_LoCntr=lCntr;
	m_InPtr=pos;
	return ret;
}

void CDekoderXL::SetNextBlock()
{
	m_Func=FNC_NOTHING;
	m_HiCntr=0;
	m_LoCntr=0;
	m_ActBits=0;
	m_FirstBit=0;
}
